<template>
    <div id="filter">
        <h2>Filter:</h2>
        <div class="filter__container">
            <label>
                Search by name:
                <input type="text" name="keyword" v-model="keywordFilter">
            </label>
        </div>
        <div class="filter__container">
            <label>
                Only available:
                <input type="checkbox" name="availableOnly" v-model="availableOnlyFilter">
            </label>
        </div>
        <div class="filter__container">
            Categories:
            <ul>
                <li
                        v-for="category in categories"
                        :key="category">
                    <label>
                        <input
                                :id="category"
                                :value="category"
                                type="checkbox"
                                v-model="categoryFilter">
                        {{ category }}
                    </label>
                </li>

            </ul>
        </div>
        <div class="filter__container">
            Colors:
            <ul>
                <li
                        v-for="color in colors"
                        :key="color">
                    <label>
                        <input
                                :id="color"
                                :value="color"
                                type="checkbox"
                                v-model="colorFilter">
                        {{ color }}
                    </label>
                </li>

            </ul>
        </div>

    </div>
</template>

<script>
import { mapState, mapMutations } from "vuex";

export default {
  name: "CatalogFilter",

  computed: {
    ...mapState({
      categories: state => state.catalog.categories,
      colors: state => state.catalog.colors,
      filters: state => state.catalog.filters
    }),

    keywordFilter: {
      get() {
        return this.$store.state.catalog.filters.keyword;
      },
      set(value) {
        this.updateFilter({ filterName: "keyword", value });
      }
    },

    availableOnlyFilter: {
      get() {
        return this.$store.state.catalog.filters.availableOnly;
      },
      set(value) {
        this.updateFilter({ filterName: "availableOnly", value });
      }
    },

    colorFilter: {
      get() {
        return this.$store.state.catalog.filters.colors;
      },
      set(value) {
        this.updateFilter({ filterName: "colors", value });
      }
    },

    categoryFilter: {
      get() {
        return this.$store.state.catalog.filters.categories;
      },
      set(value) {
        this.updateFilter({ filterName: "categories", value });
      }
    }
  },

  methods: {
    ...mapMutations("catalog", ["updateFilter"])
  }
};
</script>

<style>
#filter {
  text-align: left;
}
.filter__container {
  margin: 20px 0;
}
</style>
